//Housing,intermediary and taxes_2;
// all variables are normalaized to X/Y except l_i , i=P,I,R and lambda_i=Y*lambda_i
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

var 
//Lagrangians,*******6
lambda_P,lambda_I,lambda_R,lambda_B,lambda_m,lambda_phi,

//consumption,*****4
c_P,c_I,c_R,c_B,

//housing,******4
 h_P, h_I, h_R ,p_R,

//capital  deposit,*****4
k,d,r,r_k,

//Mortgage,****2
M,r_b,

//bank,****1
a,

//firm,******7
w_P,w_I,w_R,l_P,l_I,l_R,//Y

//Governemt,7
C,T,tr_P,tr_I,tr_R,g ,b_g,

//just for check
h,tr;
//Total=36 variables

 //predetermined_variables N ; 
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 varexo I_m ;//,I_r,tau_p,phi;


// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


parameters 
  //beta
beta_P,beta_I,beta_B,
 // housing   labor   capital
varphi_h,varphi_l,iota,delta_h,delta_k,
 // taxs
tau_c,tau_w,tau_p,tau_d,tau_k,tau_l,tau_wr,
//  I
I_r,//I_m,
 // collateral constraint,
rho_m,theta,
 // bank
phi,
 // firm,
iota_P,iota_I,iota_R,alpha_Y,A,
 // Government,
vartheta_P,vartheta_I,vartheta_R,rho_b,Expenditure_G;

// define the parameters
 //discount factors

beta_P=0.9916 ;
beta_I=0.9852 ;
beta_B= 0.957;
 //level for housing and labor in utility
varphi_h=0.28 ;
varphi_l=8.0117;//0.56 ;
 //Inverse labor suplly elasticity
iota=1 ;
 //depreciation rate
delta_h=0.0096 ;
delta_k=0.02 ;
 //Taxes
tau_c=0.05 ;
tau_w=0.18 ; //0.3
tau_wr=0.08 ; //0.2 

tau_p=0.014/4 ;
tau_d=0.15 ;
tau_k=0.4 ;
tau_l=0.0125;//0.0125;

 //Imputed rents
I_r=0 ;
 //Mortgage interest deduction
//I_m=1 ;
 //Persistence in borrowing constraint
rho_m=0.85 ;
 //loan to valye ratio
theta=0.7 ;
 //leverage ratio
phi= 0.9;
 //Labor share in production
iota_P=0.26 ; 
iota_I=0.51 ; 
iota_R= 0.23; 
 //capital share in production
alpha_Y=0.2047 ;
A= 1.805;
 //Transfer share
vartheta_P=0.036 ; 
vartheta_I=0.034 ; 
vartheta_R= 0.017; 
 // response of transfers to gov. debt
rho_b=0.001; //;
 //propertion of the gov, expenditure over output
Expenditure_G=0.18 ;
//*********************************************

model;

//lagrangians****************1,2,3,4
   (1+tau_c) * lambda_P= 1/ c_P ;
   (1+tau_c) * lambda_I= 1/ c_I ;
   (1+tau_c) * lambda_R= 1/ c_R ;
   (1+tau_c) * lambda_B= 1/ c_B ;

//budget constraints*****************************
   //Patient Household***5
   (1+tau_c)*c_P+ ( h_P-(1-delta_h)* h_P(-1))+ (  h_R-(1-delta_h)* h_R(-1))+ (k-(1-delta_k)*k(-1))+ d= 
 w_P *l_P+ p_R* h_R(-1)+ (1+r)*d(-1)+ r_k* k(-1)+ tr_P- tau_w*(w_P *l_P+(p_R-delta_h)*( h_R(-1)+I_r*  h_P(-1)) 
-tau_p  *( h_P(-1)+ h_R(-1)))-tau_d* r* d(-1)-tau_k*(r_k-delta_k)*k(-1)-tau_p  *( h_P(-1)+ h_R(-1))-tau_l  *( h_P+ h_R);

   //ImPatient Household***6
   (1+tau_c)*c_I + ( h_I -(1-delta_h)* h_I(-1))+(1+r_b)*M(-1)= 
w_I*  l_I +M +tr_I -tau_w*(w_I *l_I -I_m *r_b*M(-1)+I_r*(p_R -delta_h)*  h_I(-1)-tau_p   *  h_I(-1))-tau_p  *  h_I(-1)-tau_l *   h_I ;

   //Renter Household***7
   (1+tau_c)*c_R +p_R*   h_R(-1)= (1-tau_wr)*w_R * l_R +tr_R ;

   //Bank***8,9
   a =b_g +M ;
   // a=M;
   (1+tau_c)* c_B +(1+r)*d(-1)+a =d +(1+r_b)*a(-1);

// Optimal conditions****************
   //Respect to h_P***10
   (1+ tau_l)  = beta_P* ( (varphi_h/ (lambda_P *  h_P)) + (lambda_P(1)/ lambda_P )*((1- delta_h- tau_p*(1- tau_w))-I_r * tau_w*(p_R(1)- delta_h)));

   //Respect to h_R***11
   (1+ tau_l)  = beta_P * ( (lambda_P(1)/ lambda_P )*((1- delta_h- tau_p*(1- tau_w))+(1- tau_w)*p_R(1)+ tau_w * delta_h));
 
   //Respect to d***12
   1= beta_P * ( (lambda_P(1)/ lambda_P )*(1+(1- tau_d)*r(1) )) ; 

   //Respect to k***13
   1 = beta_P*  ( (lambda_P(1)/ lambda_P )*(1- delta_k+(1- tau_k)*r_k(1)+ tau_k*  delta_k));  

   //Respect to h_I***14
   (1+ tau_l-  (lambda_m / lambda_I )*(1- rho_m)* theta)  = beta_I*  ( ( varphi_h/( lambda_I *  h_I)) 
+ (lambda_I(1)/ lambda_I )*(1- delta_h- tau_p*(1- tau_w)-I_r * tau_w*(p_R(1)- delta_h)));  

   //Respect to Mortgage***15
   1- (lambda_m / lambda_I )= beta_I * ( (lambda_I(1)/ lambda_I )*(1+(1-I_m *tau_w)*r(1) - (lambda_m(1)/ lambda_I )* rho_m)) ; 

   //Respect to h_R ***16
   p_R = ( varphi_h/( lambda_R*  h_R(-1)));

   //Respect to labors***17,18,19
  //varphi_l *(l_P )^iota= lambda_P * (1- tau_w)*w_P  ; 
  //varphi_l *(l_I )^iota= lambda_I * (1- tau_w)*w_I   ;
  //varphi_l *(l_R )^iota= lambda_R * (1- tau_wr)*w_R ;  
l_P=0.30;l_I=0.3777;l_R=0.3606;

   //Respect to d bank***20
   1=(lambda_phi/lambda_B)+   beta_B*  (lambda_B(1)/ lambda_B ) *(1+r(1) )  ;

   //Respect to "a": asset bank***21
   1=(lambda_phi/lambda_B)* phi+  beta_B*  (lambda_B(1)/ lambda_B )*(1+r_b(1) ) ; 

   //Firm problem
   //Y =A * k(-1)^alpha_Y* ((l_P )^iota_P * (l_I )^iota_I * (l_R )^iota_R)^(1- alpha_Y);//22
   alpha_Y* (1 /k(-1))=r_k   ;//22
   (1- alpha_Y)* iota_P* (1 /l_P)=w_P ;//23
   (1- alpha_Y)* iota_I* (1 /l_I)=w_I ;//24
   (1- alpha_Y)* iota_R* (1 /l_R)=w_R ;//25

// borrowing constraint******************************
   M =  rho_m* M(-1)+(1- rho_m)* theta   * h_I ;//26
   d = phi * a ;//27

//Government*********************************
   C =c_P +c_I +c_R +c_B   ;//28
 T = tau_c* C + tau_w*(w_P* l_P +(p_R - delta_h)*( h_R(-1)+I_r * h_P(-1))- tau_p  * ( h_P(-1)+ h_R(-1)))+ tau_d *r* d(-1) 
 + tau_p * ( h_P(-1)+ h_R(-1))+ tau_l  *( h_P + h_R )+ tau_k*(r_k - delta_k)*k(-1) 
 + tau_w*(w_I* l_I -I_m* r_b*M(-1)+I_r*(p_R - delta_h)*  h_I(-1)- tau_p   *  h_I(-1))+ tau_p  *   h_I(-1)+ tau_l  *  h_I   
 + tau_wr*w_R*  l_R;   //29

   b_g +T =(1+r_b)*b_g(-1)+g + tr_P + tr_I + tr_R   ;//30
   tr_P = vartheta_P *1 - rho_b* b_g(-1);//31
   tr_I = vartheta_I *1 - rho_b* b_g(-1);//32
   tr_R = vartheta_R *1 - rho_b* b_g(-1);//33
   g=Expenditure_G; //34
   h=h_P+h_I+h_R;//35
   tr=tr_P+tr_I+tr_R;//36
end;
// ***********************************
load just_for_check_0.mat;
initval;
lambda_P=lambda_P_0;lambda_I=lambda_I_0;lambda_R=lambda_R_0;
lambda_B=lambda_B_0;lambda_m=lambda_m_0;lambda_phi=lambda_phi_0;
c_P=c_P_0; c_I=c_I_0; c_R=c_R_0; c_B=c_B_0; 
h_P=h_P_0; h_I=h_I_0; h_R=h_R_0;  p_R=p_R_0;
k=k_0; d=d_0; r=r_0; r_k=r_k_0;M=M_0; r_b=r_b_0;
a=a_0; w_P=w_P_0; w_I=w_I_0; w_R=w_R_0;
l_P=l_P_0; l_I=l_I_0; l_R=l_R_0;
C=C_0; T=T_0; b_g=b_g_0; tr_P=tr_P_0; tr_I=tr_I_0; tr_R=tr_R_0; g=g_0;
h=h_0;tr=tr_0;
//
I_m=1;
end;

// ***********************************

steady;

check;
%model_diagnostics ;

shocks;
var I_m;
periods 1:10;
values 1.1;
end;


simul(periods=1000,stack_solve_algo =0);










